# Generated by Django 3.1.3 on 2020-11-27 20:02

import base64
import json

import django.core.files.base
from django.db import migrations, models
import django.db.models.deletion


def migrate_json(tree_model, report, jdata_k, jdata, lft):
    rgt = lft

    img_idx = 0

    for (k, v) in jdata.items():
        if isinstance(v, dict):
            rgt += migrate_json(tree_model, report, k, v, rgt)
            continue

        if (k == 'image' or k == 'picture') and len(v) <= 64:
            # weird crap in some reports ?
            continue
        if k == 'image' or k == 'picture':
            v = base64.decodebytes(v.encode("utf-8"))
            attachment = tree_model['attachment'](
                file_name="{}_{}_{}.png".format(k, report.id, img_idx),
                report=report
            )
            attachment.attachment.save(
                "{}_{}_{}.png".format(k, report.id, img_idx),
                django.core.files.base.ContentFile(v)
            )
            attachment.save()
            img_idx += 1
            continue
        else:
            model = (
                'field_integer'
                if isinstance(v, int)
                else 'field_string'
            )
            content_type = tree_model[
                'contenttype_integer'
                if isinstance(v, int)
                else 'contenttype_string'
            ]
            if not isinstance(v, int):
                v = str(v)
                if len(v) > 8180:
                    print("{}: {} = {}".format(jdata_k, k, len(v)))
                    v = v[:8180]
            content = tree_model[model].objects.create(
                value=v
            )

        tree_model['node'](
            report=report,
            name=k,
            lft=rgt,
            rgt=rgt,
            content_type=content_type,
            content_id=content.id
        ).save()
        rgt += 1

    tree_model['node'].objects.create(
        report=report,
        name=jdata_k,
        lft=lft,
        rgt=rgt
    )
    return (rgt - lft) + 1


def migrate_scanner_db(apps, schema_editor):
    if schema_editor.connection.alias != 'default':
        return

    model_in_reports = apps.get_model("scannerdb", "Report")
    model_manufacturer = apps.get_model("backend", "ScannerManufacturer")
    model_scanner = apps.get_model("backend", "Scanner")
    model_out_report = apps.get_model("backend", "ScanReport")

    contenttype = apps.get_model("contenttypes", "ContentType")

    tree_model = {
        'node': apps.get_model("backend", "ScanReportTreeNode"),
        'field_string': apps.get_model("backend", "ScanReportFieldString"),
        'field_integer':  apps.get_model("backend", "ScanReportFieldInteger"),
        'attachment': apps.get_model("backend", "ScanReportAttachment"),
    }
    tree_model['contenttype_string'] = contenttype.objects.get_for_model(
        tree_model['field_string']
    )
    tree_model['contenttype_integer'] = contenttype.objects.get_for_model(
        tree_model['field_integer']
    )

    in_reports = model_in_reports.objects.all().defer("body")
    for in_report in in_reports:
        print("Migrating report {}".format(in_report.id))

        # Use a separate queryset to load the report, because we want
        # to load and use the body field only one by one and release them
        # each time.
        in_report = model_in_reports.objects.get(id=in_report.id)
        in_body = json.loads(in_report.body)

        if 'scantest' not in in_body:
            in_body['scantest'] = {}

        in_manufacturer = in_report.scanner.manufacturer
        (out_manufacturer, _) = model_manufacturer.objects.update_or_create(
            # reuse ID --> makes it easier to check that the migration
            # actually worked
            id=in_manufacturer.id,
            defaults={
                'name': in_manufacturer.name,
                'creation_date': in_manufacturer.creation_date,
                'moderated': in_manufacturer.moderated,
            }
        )

        in_scanner = in_report.scanner
        (out_scanner, _) = model_scanner.objects.update_or_create(
            # reuse ID --> makes it easier to check that the migration
            # actually worked
            id=in_scanner.id,
            defaults={
                'name': in_scanner.name,
                'manufacturer': out_manufacturer,
                'creation_date': in_scanner.creation_date,
                'moderated': in_scanner.moderated,
            }
        )

        scan_source = ""
        if 'source' in in_body['scantest']['config']:
            scan_source = in_body['scantest']['config']['source']

        out_report = model_out_report.objects.create(
            # reuse report ID --> makes it easier to check that the migration
            # actually worked
            id=in_report.id,
            creation_date=in_report.creation_date,
            last_update=in_report.creation_date,
            secret_key="",
            sealed=True,
            scanner=out_scanner,
            moderated=in_report.moderated,
            successful=in_report.successful,
            admin_comment=in_report.rejection_reason,
            user_email=in_report.user_email,
            os=in_report.os.name,
            scan_library=in_report.library.name,
            scan_program=in_report.program.name,
            scanner_type=in_body['scanner']['type'],
            scan_source=scan_source,
        )
        out_report.creation_date = in_report.creation_date
        out_report.save()

        in_body['software'] = {
            'scan_library': in_report.library.name,
            'test_program': in_report.program.name,
            'operating_system': in_report.os.name,
        }

        lft = 0
        for (k, v) in in_body.items():
            if k != 'traces':
                lft += migrate_json(tree_model, out_report, k, v, lft)
                continue

            v = v.encode("utf-8")
            try:
                v = base64.decodebytes(v)
            except Exception as exc:
                print(
                    "Warning: failed to decode {} base64 bytes."
                    " Using as is. Error: {}".format(len(v), str(exc))
                )
            attachment = tree_model['attachment'](
                file_name="{}_traces.txt".format(out_report.id),
                report=out_report
            )
            attachment.attachment.save(
                "{}_traces.txt".format(out_report.id),
                django.core.files.base.ContentFile(v)
            )
            attachment.save()


class Migration(migrations.Migration):
    initial = True

    dependencies = [
        ('scannerdb', '0002_auto_20180222_2132'),
        ('contenttypes', '0002_remove_content_type_name'),
    ]

    operations = [
        migrations.CreateModel(
            name='Scanner',
            fields=[
                (
                    'id', models.AutoField(
                        auto_created=True, primary_key=True, serialize=False,
                        verbose_name='ID'
                    )
                ),
                ('creation_date', models.DateTimeField(auto_now_add=True)),
                ('last_mod_date', models.DateTimeField(auto_now=True)),
                ('moderated', models.BooleanField(default=False)),
                ('name', models.CharField(db_index=True, max_length=128)),
            ],
        ),
        migrations.CreateModel(
            name='ScannerManufacturer',
            fields=[
                (
                    'id', models.AutoField(
                        auto_created=True, primary_key=True, serialize=False,
                        verbose_name='ID'
                    )
                ),
                ('creation_date', models.DateTimeField(auto_now_add=True)),
                ('last_mod_date', models.DateTimeField(auto_now=True)),
                ('moderated', models.BooleanField(default=False)),
                ('name', models.CharField(
                    db_index=True, max_length=128, unique=True
                )),
            ],
        ),
        migrations.CreateModel(
            name='ScanReport',
            fields=[
                (
                    'id', models.AutoField(
                        auto_created=True, primary_key=True, serialize=False,
                        verbose_name='ID'
                    )
                ),
                (
                    'creation_date', models.DateTimeField(
                        auto_now_add=True, db_index=True
                    )
                ),
                ('last_update', models.DateTimeField(auto_now=True)),
                ('secret_key', models.CharField(blank=True, max_length=64)),
                ('sealed', models.BooleanField()),
                (
                    'moderated', models.BooleanField(
                        db_index=True, default=False
                    )
                ),
                (
                    'successful', models.BooleanField(
                        db_index=True, default=False
                    )
                ),
                (
                    'admin_comment', models.CharField(
                        blank=True, max_length=255, null=True, default=None
                    )
                ),
                (
                    'scanner', models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        to='backend.scanner',
                        db_index=True
                    )
                ),
                (
                    'user_email', models.EmailField(
                        blank=True, max_length=254, null=True
                    )
                ),
                (
                    'os', models.CharField(
                        max_length=128, null=False, blank=False, db_index=True
                    )
                ),
                (
                    'scan_source', models.CharField(
                        max_length=128, null=False, blank=True, db_index=False
                    ),
                ),
                (
                    'scan_library', models.CharField(
                        max_length=128, null=False, blank=False, db_index=False
                    ),
                ),
                (
                    'scan_program', models.CharField(
                        max_length=128, null=False, blank=False, db_index=False
                    ),
                ),
                (
                    'scanner_type', models.CharField(
                        max_length=64, null=False, blank=False, db_index=False
                    ),
                ),
            ],
        ),
        migrations.CreateModel(
            name='ScanReportAttachment',
            fields=[
                (
                    'id', models.AutoField(
                        auto_created=True, primary_key=True, serialize=False,
                        verbose_name='ID'
                    )
                ),
                (
                    'report', models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        to='backend.scanreport'
                    )
                ),
                (
                    'file_name', models.CharField(
                        max_length=64, null=False, blank=False, db_index=False
                    )
                ),
                (
                    'attachment', models.FileField(
                        upload_to='scan_report_attachments'
                    )
                ),
            ],
        ),
        migrations.CreateModel(
            name='ScanReportFieldInteger',
            fields=[
                (
                    'id', models.AutoField(
                        auto_created=True, primary_key=True, serialize=False,
                        verbose_name='ID'
                    )
                ),
                ('value', models.BigIntegerField(db_index=True)),
            ],
        ),
        migrations.CreateModel(
            name='ScanReportFieldString',
            fields=[
                (
                    'id', models.AutoField(
                        auto_created=True, primary_key=True, serialize=False,
                        verbose_name='ID'
                    )
                ),
                ('value', models.CharField(max_length=8190, db_index=True)),
            ],
        ),
        migrations.CreateModel(
            name='ScanReportTreeNode',
            fields=[
                (
                    'id', models.AutoField(
                        auto_created=True, primary_key=True, serialize=False,
                        verbose_name='ID'
                    )
                ),
                ('lft', models.IntegerField()),
                ('rgt', models.IntegerField()),
                (
                    'content_id', models.PositiveIntegerField(
                        default=None, null=True
                    )
                ),
                (
                    'content_type', models.ForeignKey(
                        db_index=False, default=None, null=True,
                        on_delete=django.db.models.deletion.CASCADE,
                        to='contenttypes.contenttype'
                    )
                ),
                ('name', models.CharField(db_index=True, max_length=128)),
                (
                    'report', models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        to='backend.scanreport'
                    )
                ),
            ],
        ),
        migrations.AddField(
            model_name='scanner',
            name='manufacturer',
            field=models.ForeignKey(
                on_delete=django.db.models.deletion.CASCADE,
                to='backend.scannermanufacturer'
            ),
        ),
        migrations.AlterIndexTogether(
            name='scanner',
            index_together={('name', 'manufacturer')},
        ),
        migrations.AlterUniqueTogether(
            name='scanner',
            unique_together={('manufacturer', 'name')},
        ),

        migrations.RunPython(migrate_scanner_db),
    ]
